// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// ServiceAccount is an autogenerated mock type for the ServiceAccount type
type ServiceAccount struct {
	mock.Mock
}

// CreateServiceAccount provides a mock function with given fields: ctx, input
func (_m *ServiceAccount) CreateServiceAccount(ctx context.Context, input *types.CreateServiceAccountInput) (*types.ServiceAccount, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ServiceAccount
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateServiceAccountInput) (*types.ServiceAccount, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateServiceAccountInput) *types.ServiceAccount); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ServiceAccount)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateServiceAccountInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateToken provides a mock function with given fields: ctx, input
func (_m *ServiceAccount) CreateToken(ctx context.Context, input *types.ServiceAccountCreateTokenInput) (*types.ServiceAccountCreateTokenResponse, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ServiceAccountCreateTokenResponse
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.ServiceAccountCreateTokenInput) (*types.ServiceAccountCreateTokenResponse, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.ServiceAccountCreateTokenInput) *types.ServiceAccountCreateTokenResponse); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ServiceAccountCreateTokenResponse)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.ServiceAccountCreateTokenInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteServiceAccount provides a mock function with given fields: ctx, input
func (_m *ServiceAccount) DeleteServiceAccount(ctx context.Context, input *types.DeleteServiceAccountInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteServiceAccountInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetServiceAccount provides a mock function with given fields: ctx, input
func (_m *ServiceAccount) GetServiceAccount(ctx context.Context, input *types.GetServiceAccountInput) (*types.ServiceAccount, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ServiceAccount
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetServiceAccountInput) (*types.ServiceAccount, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetServiceAccountInput) *types.ServiceAccount); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ServiceAccount)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetServiceAccountInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UpdateServiceAccount provides a mock function with given fields: ctx, input
func (_m *ServiceAccount) UpdateServiceAccount(ctx context.Context, input *types.UpdateServiceAccountInput) (*types.ServiceAccount, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.ServiceAccount
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateServiceAccountInput) (*types.ServiceAccount, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.UpdateServiceAccountInput) *types.ServiceAccount); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.ServiceAccount)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.UpdateServiceAccountInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewServiceAccount interface {
	mock.TestingT
	Cleanup(func())
}

// NewServiceAccount creates a new instance of ServiceAccount. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewServiceAccount(t mockConstructorTestingTNewServiceAccount) *ServiceAccount {
	mock := &ServiceAccount{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
